#!/bin/bash

date
echo ===== uptime =====
uptime

X=$(cat /var/cage_id)
XX=(${X})
TYPE=${XX[4]}
echo Module type is ${TYPE}

echo ===== node 0 power check =====
X=$(i2c 0:0x60:0=2 0:0x60:0/1)
echo ${X}
XX=(${X})
P0=${XX[4]}
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 power check =====
    X=$(i2c 1:0x60:0=2 1:0x60:0/1)
    echo ${X}
    XX=(${X})
    P1=${XX[4]}
    echo ===== node 2 power check =====
    X=$(i2c 2:0x60:0=2 2:0x60:0/1)
    echo ${X}
    XX=(${X})
    P2=${XX[4]}
fi
echo ===== node 3 power check =====
X=$(i2c 3:0x60:0=2 3:0x60:0/1)
echo ${X}
XX=(${X})
P3=${XX[4]}
if [ ${TYPE} == 'I/O' ]; then
    echo ===== riser 0 power check =====
    X=$(i2c 4:0x60:0=2 4:0x60:0/1)
    echo ${X}
    echo ===== riser 1 power check =====
    X=$(i2c 4:0x61:0=2 4:0x61:0/1)
    echo ${X}
    echo ===== riser 2 power check =====
    X=$(i2c 4:0x62:0=2 4:0x62:0/1)
    echo ${X}
    echo ===== riser 3 power check =====
    X=$(i2c 4:0x63:0=2 4:0x63:0/1)
    echo ${X}
fi
echo ===== verty 0 power check =====
X=$(i2c 5:0x60:0=2 5:0x60:0/1)
echo ${X}
echo ===== verty 1 power check =====
X=$(i2c 5:0x61:0=2 5:0x61:0/1)
echo ${X}
echo ===== verty 2 power check =====
X=$(i2c 5:0x62:0=2 5:0x62:0/1)
echo ${X}
if [ ${TYPE} != 'I/O' ]; then
    echo ===== verty 3 power check =====
    X=$(i2c 5:0x63:0=2 5:0x63:0/1)
    echo ${X}
fi
echo ===== mezz power check =====
X=$(i2c 7:0x60:0=2 7:0x60:0/1)
echo ${X}

echo ===== voltages =====
if [ ${TYPE} != 'I/O' ]; then
    vsense 0:0x60 1:0x60 2:0x60 3:0x60 5:0x60 5:0x61 5:0x62 5:0x63 7:0x60
else
    vsense 0:0x60 3:0x60 4:0x60 4:0x61 4:0x62 4:0x63 5:0x60 5:0x61 5:0x62 7:0x60
fi

echo ===== temperatures =====
if [ ${TYPE} != 'I/O' ]; then
    tsense 0:0x60 1:0x60 2:0x60 3:0x60 7:0x60
else
    tsense 0:0x60 3:0x60 4:0x60 4:0x61 4:0x62 4:0x63 7:0x60
fi

echo ===== node 0 amps =====
i2c 0:0x60:0=6 0:0x60:0/1
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 amps =====
    i2c 1:0x60:0=6 1:0x60:0/1
    echo ===== node 2 amps =====
    i2c 2:0x60:0=6 2:0x60:0/1
fi
echo ===== node 3 amps =====
i2c 3:0x60:0=6 3:0x60:0/1
echo ===== verty 0 amps =====
i2c 5:0x60:0=6 5:0x60:0/1
echo ===== verty 1 amps =====
i2c 5:0x61:0=6 5:0x61:0/1
echo ===== verty 2 amps =====
i2c 5:0x62:0=6 5:0x62:0/1
if [ ${TYPE} != 'I/O' ]; then
    echo ===== verty 3 amps =====
    i2c 5:0x63:0=6 5:0x63:0/1
fi
echo ===== mezz amps =====
i2c 7:0x60:0=6 7:0x60:0/1

echo ===== node 0 health =====
i2c 0:0x60:0=3 0:0x60:0/3
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 health =====
    i2c 1:0x60:0=3 1:0x60:0/3
    echo ===== node 2 health =====
    i2c 2:0x60:0=3 2:0x60:0/3
fi
echo ===== node 3 health =====
i2c 3:0x60:0=3 3:0x60:0/3
if [ ${TYPE} == 'I/O' ]; then
    echo ===== riser 0 health =====
    i2c 4:0x60:0=3 4:0x60:0/1
    echo ===== riser 1 health =====
    i2c 4:0x61:0=3 4:0x61:0/1
    echo ===== riser 2 health =====
    i2c 4:0x62:0=3 4:0x62:0/1
    echo ===== riser 3 health =====
    i2c 4:0x63:0=3 4:0x63:0/1
fi
echo ===== verty 0 health =====
i2c 5:0x60:0=3 5:0x60:0/1
echo ===== verty 1 health =====
i2c 5:0x61:0=3 5:0x61:0/1
echo ===== verty 2 health =====
i2c 5:0x62:0=3 5:0x62:0/1
if [ ${TYPE} != 'I/O' ]; then
    echo ===== verty 3 health =====
    i2c 5:0x63:0=3 5:0x63:0/1
fi
echo ===== mezz health =====
i2c 7:0x60:0=3 7:0x60:0/3

echo ===== node 0 EngReg =====
i2c 0:0x60:0=0x12 0:0x60:0/10
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 EngReg =====
    i2c 1:0x60:0=0x12 1:0x60:0/10
    echo ===== node 2 EngReg =====
    i2c 2:0x60:0=0x12 2:0x60:0/10
fi
echo ===== node 3 EngReg =====
i2c 3:0x60:0=0x12 3:0x60:0/10

HDT=1
if [ ${P0} != 0x41 ]; then
    HDT=0
fi
if [ ${TYPE} == 'I/O' ]; then
    if [ ${P1} != 0x41 ]; then
        HDT=0
    fi
    if [ ${P2} != 0x41 ]; then
        HDT=0
    fi
fi
if [ ${P3} != 0x41 ]; then
    HDT=0
fi

if [ ${HDT} == 1 ]; then
    echo ===== node 0 hdt =====
    hdt -r1 -n0
    if [ ${TYPE} == 'I/O' ]; then
        echo ===== node 1 hdt =====
        hdt -r1 -n1
        echo ===== node 2 hdt =====
        hdt -r1 -n2
    fi
    echo ===== node 3 hdt =====
    hdt -r1 -n3
    
    echo ===== node 0 northbridge =====
    hdt -m 0x411 -n0
    hdt -m 0x412 -n0
    if [ ${TYPE} == 'I/O' ]; then
        echo ===== node 1 northbridge =====
        hdt -m 0x411 -n1
        hdt -m 0x412 -n1
        echo ===== node 2 northbridge =====
        hdt -m 0x411 -n2
        hdt -m 0x412 -n2
    fi
    echo ===== node 3 northbridge =====
    hdt -m 0x411 -n3
    hdt -m 0x412 -n3
else
    echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    echo '! All nodes are NOT powered on !'
    echo '!   hdt will NOT be executed   !'
    echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
fi
